package de.tub.mapc.Coordination.goals;

import java.util.Random;

import de.jiac.micro.agent.memory.IFact;
import de.tub.mapc.IMAPCConstants;
import de.tub.mapc.components.contestagents.MessageService;
import de.tub.mapc.components.contestagents.handle.IPathFindingHandle;
import de.tub.mapc.knowledge.Gridworld;
import de.tub.mapc.knowledge.Perception;
import de.tub.mapc.knowledge.Position;

public abstract class AbstractGoal implements IFact{
	
	public String getRandomAction(){
		String[] directions = new String[8];
		directions[0] = IMAPCConstants.ACTION_EAST;
		directions[1] = IMAPCConstants.ACTION_WEST;
		directions[2] = IMAPCConstants.ACTION_NORTH;
		directions[3] = IMAPCConstants.ACTION_SOUTH;
		directions[4] = IMAPCConstants.ACTION_NORTHEAST;
		directions[5] = IMAPCConstants.ACTION_SOUTHWEST;
		directions[6] = IMAPCConstants.ACTION_NORTHWEST;
		directions[7] = IMAPCConstants.ACTION_SOUTHEAST;
		Random r = new Random();
		return directions[r.nextInt(8)];
	}
	
//	public Position getGoalPosition(){
//		return new Position(-1, -1);
//	}

	public abstract Position getGoalPosition();
	
	/**
	 * finds the next action which will help to achieve this goal
	 * 
	 * @param perception the last perception of this agent 
	 * @param world the information about the world
	 * @param pathfinder the pathfinder og this agent
	 * @param coordinatorMessageService a messageservice, which can be used
	 *        to communicate with the coordinatoragent, e.g. to send switch votes
	 * @return an action string, not null
	 * 
	 */
	public abstract String getAction(Perception perception, Gridworld world, IPathFindingHandle pathfinder, MessageService coordinatorMessageService);
	
	/**
	 * returns the priority of this goal
	 * @return
	 */
	public abstract int getPriority();
	
	/**
	 * 
	 * @return true, if the goal is achieved
	 */
	public abstract boolean isAchieved();
	
	/**
	 * @return a String representation of this goal
	 */
	public abstract String toString();
	/**
	 * @param o another goal
	 * @return true, if the other goal is the same
	 */
	public abstract boolean equals(Object o);
}
