package de.tub.mapc.Coordination.messages;

import java.io.IOException;

import de.dailab.keks.io.IDeserialiser;
import de.dailab.keks.io.ISerialiser;
import de.jiac.micro.agent.memory.IFact;
import de.tub.mapc.knowledge.Position;

public class MessageSwitchVote extends Position implements IFact {

	boolean isFence;
	int distance;
	
	public MessageSwitchVote(){
		super();
	}
	
	public MessageSwitchVote(int x, int y, boolean isFence, int dist){
		super(x,y);
		this.isFence = isFence;
		this.distance = dist;
	}
	
	public boolean isFence() {
		return isFence;
	}

	public void setFence(boolean isFence) {
		this.isFence = isFence;
	}

	public int getDistance() {
		return distance;
	}

	public void setDistance(int distance) {
		this.distance = distance;
	}

	@Override
	public void deserialise(IDeserialiser in) throws IOException,
			ClassNotFoundException {
		super.deserialise(in);
		isFence = in.readBoolean();
		distance = in.readInt();
	}

	@Override
	public void serialise(ISerialiser out) throws IOException {
		super.serialise(out);
		out.writeBoolean(isFence);
		out.writeInt(distance);
	}

}
