package de.tub.mapc.knowledge;

import java.io.IOException;

import de.dailab.keks.io.IDeserialiser;
import de.dailab.keks.io.ISerialiser;
import de.jiac.micro.agent.memory.IFact;

public class Position implements IFact{

	private int x;
	private int y;
	private int id;
	
	public static int getIDForXY(int x, int y){
		return (x << 16) | y;
	}
	
	public Position(){
		generateId();
	}
	
	public Position(int x, int y){
		this.x = x;
		this.y = y;
		generateId();
	}
	
	public final void setX(int x) {
		this.x = x;
		generateId();
	}

	public int getX() {
		return x;
	}

	public final void setY(int y) {
		this.y = y;
		generateId();
	}
	
	public int getY() {
		return y;
	}
	
	public final int getId(){
		return id; 
	}
	
	private void generateId(){
	    // manually inlined ;-)
		id =  (x << 16) | y;
	}
	
	/**
	 * returns true, if the x and y coordinate are the same
	 */
	@Override
	public boolean equals(Object obj) {
		if(obj instanceof Position) {
		    return id == ((Position) obj).id;
		}
		
		return false;
	}
	
	@Override
    public int hashCode() {
        return id;
    }

    @Override
	public String toString() {
		return "("+x+", "+y+")";
	}
	
	@Override
	public void deserialise(IDeserialiser arg0) throws IOException,
			ClassNotFoundException {
		x = arg0.readInt();
		y = arg0.readInt();
		generateId();
	}

	@Override
	public void serialise(ISerialiser arg0) throws IOException {
		arg0.writeInt(x);
		arg0.writeInt(y);
	}

}
