/*
 * $Id: IntHashSet.java 7269 2010-08-23 13:26:32Z tuguldur $
 */
package de.tub.mapc.lang;

/**
 * @author Marcel Patzlaff
 * @version $Revision: 7269 $
 */
public class IntHashSet {
    private static final Object DUMMY= new Object();
    
    private final IntHashMap<Object> _map;
    
    public IntHashSet() {
        _map= new IntHashMap<Object>();
    }
    
    public IntHashSet(int initialCapacity) {
        _map= new IntHashMap<Object>(initialCapacity);
    }
    
    public boolean contains(int val) {
        return _map.containsKey(val);
    }
    
    public boolean add(int val) {
        return _map.put(val, DUMMY) != DUMMY;
    }
    
    public boolean remove(int val) {
        return _map.remove(val) == DUMMY;
    }
    
    public int size() {
        return _map.size();
    }
    
    public void clear() {
    	_map.clear();
    }
}
